Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::DefaultRaySceneQuery Class Reference

Default implementation of RaySceneQuery. More...

`#include <OgreSceneManager.h>`

Inheritance diagram for Ogre::DefaultRaySceneQuery:

[legend]
List of all members.

## Public Types
enum | WorldFragmentType { WFT_NONE, WFT_PLANE_BOUNDED_REGION, WFT_SINGLE_INTERSECTION, WFT_CUSTOM_GEOMETRY, WFT_RENDER_OPERATION }
| This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries. More...
## Public Member Functions
| DefaultRaySceneQuery (SceneManager *creator)
| ~DefaultRaySceneQuery ()
void | execute (RaySceneQueryListener *listener)
| See RayScenQuery.
virtual void | setRay (const Ray &ray)
| Sets the ray which is to be used for this query.
virtual const Ray & | getRay (void) const
| Gets the ray which is to be used for this query.
virtual void | setSortByDistance (bool sort, ushort maxresults=0)
| Sets whether the results of this query will be sorted by distance along the ray.
virtual bool | getSortByDistance (void) const
| Gets whether the results are sorted by distance.
virtual ushort | getMaxResults (void) const
| Gets the maximum number of results returned from the query (only relevant if results are being sorted).
virtual RaySceneQueryResult & | execute (void)
| Executes the query, returning the results back in one list.
virtual RaySceneQueryResult & | getLastResults (void)
| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.
virtual void | clearResults (void)
| Clears the results of the last query execution.
bool | queryResult (MovableObject *obj, Real distance)
| Self-callback in order to deal with execute which returns collection.
bool | queryResult (SceneQuery::WorldFragment *fragment, Real distance)
| Self-callback in order to deal with execute which returns collection.
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual uint32 | getQueryMask (void) const
| Returns the current mask for this query.
virtual void | setQueryTypeMask (uint32 mask)
| Sets the type mask for results of this query.
virtual uint32 | getQueryTypeMask (void) const
| Returns the current mask for this query.
virtual void | setWorldFragmentType (enum WorldFragmentType wft)
| Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed.
virtual WorldFragmentType | getWorldFragmentType (void) const
| Gets the current world fragment types to be returned from the query.
virtual const std::set< WorldFragmentType > * | getSupportedWorldFragmentTypes (void) const
| Returns the types of world fragments this query supports.
## Protected Attributes
Ray | mRay
bool | mSortByDistance
ushort | mMaxResults
RaySceneQueryResult | mResult
SceneManager * | mParentSceneMgr
uint32 | mQueryMask
uint32 | mQueryTypeMask
std::set< WorldFragmentType > | mSupportedWorldFragments
WorldFragmentType | mWorldFragmentType

## Detailed Description

Default implementation of RaySceneQuery.

Definition at line 2763 of file OgreSceneManager.h.

## Member Enumeration Documentation

enum Ogre::SceneQuery::WorldFragmentType`[inherited]`

  | This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries. Not all these types will be supported by all SceneManagers; once the application has decided which SceneManager specialisation to use, it is expected that it will know which type of world geometry abstraction is available to it. Enumeration values:
  WFT_NONE | Return no world geometry hits at all.
  WFT_PLANE_BOUNDED_REGION | Return pointers to convex plane-bounded regions.
  WFT_SINGLE_INTERSECTION | Return a single intersection point (typically RaySceneQuery only).
  WFT_CUSTOM_GEOMETRY | Custom geometry as defined by the SceneManager.
  WFT_RENDER_OPERATION | General RenderOperation structure.
Definition at line 77 of file OgreSceneQuery.h.

## Constructor & Destructor Documentation

Ogre::DefaultRaySceneQuery::DefaultRaySceneQuery | ( | SceneManager * | creator | ) |

Ogre::DefaultRaySceneQuery::~DefaultRaySceneQuery | ( |  | ) |

## Member Function Documentation

virtual void Ogre::RaySceneQuery::clearResults | ( | void |  | ) | `[virtual, inherited]`

| Clears the results of the last query execution. Remarks: You only need to call this if you specifically want to free up the memory used by this object to hold the last query results. This object clears the results itself when executing and when destroying itself.

virtual RaySceneQueryResult& Ogre::RaySceneQuery::execute | ( | void |  | ) | `[virtual, inherited]`

| Executes the query, returning the results back in one list. Remarks: This method executes the scene query as configured, gathers the results into one structure and returns a reference to that structure. These results will also persist in this query object until the next query is executed, or clearResults() is called. An more lightweight version of this method that returns results through a listener is also available.

void Ogre::DefaultRaySceneQuery::execute | ( | RaySceneQueryListener * | listener | ) | `[virtual]`

| See RayScenQuery. Implements Ogre::RaySceneQuery.

virtual RaySceneQueryResult& Ogre::RaySceneQuery::getLastResults | ( | void |  | ) | `[virtual, inherited]`

| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.

virtual ushort Ogre::RaySceneQuery::getMaxResults | ( | void |  | ) | const`[virtual, inherited]`

| Gets the maximum number of results returned from the query (only relevant if results are being sorted).

virtual uint32 Ogre::SceneQuery::getQueryMask | ( | void |  | ) | const`[virtual, inherited]`

| Returns the current mask for this query.

virtual uint32 Ogre::SceneQuery::getQueryTypeMask | ( | void |  | ) | const`[virtual, inherited]`

| Returns the current mask for this query.

virtual const Ray& Ogre::RaySceneQuery::getRay | ( | void |  | ) | const`[virtual, inherited]`

| Gets the ray which is to be used for this query.

virtual bool Ogre::RaySceneQuery::getSortByDistance | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether the results are sorted by distance.

virtual const std::set<WorldFragmentType>* Ogre::SceneQuery::getSupportedWorldFragmentTypes | ( | void |  | ) | const`[virtual, inherited]`

| Returns the types of world fragments this query supports. Definition at line 169 of file OgreSceneQuery.h.

virtual WorldFragmentType Ogre::SceneQuery::getWorldFragmentType | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current world fragment types to be returned from the query.

bool Ogre::RaySceneQuery::queryResult | ( | SceneQuery::WorldFragment * | fragment,
|  | Real | distance
| ) | `[virtual, inherited]`

| Self-callback in order to deal with execute which returns collection. Implements Ogre::RaySceneQueryListener.

bool Ogre::RaySceneQuery::queryResult | ( | MovableObject * | obj,
|  | Real | distance
| ) | `[virtual, inherited]`

| Self-callback in order to deal with execute which returns collection. Implements Ogre::RaySceneQueryListener.

virtual void Ogre::SceneQuery::setQueryMask | ( | uint32 | mask | ) | `[virtual, inherited]`

| Sets the mask for results of this query. Remarks: This method allows you to set a 'mask' to limit the results of this query to certain types of result. The actual meaning of this value is up to the application; basically MovableObject instances will only be returned from this query if a bitwise AND operation between this mask value and the MovableObject::getQueryFlags value is non-zero. The application will have to decide what each of the bits means.

virtual void Ogre::SceneQuery::setQueryTypeMask | ( | uint32 | mask | ) | `[virtual, inherited]`

| Sets the type mask for results of this query. Remarks: This method allows you to set a 'type mask' to limit the results of this query to certain types of objects. Whilst setQueryMask deals with flags set per instance of object, this method deals with setting a mask on flags set per type of object. Both may exclude an object from query results.

virtual void Ogre::RaySceneQuery::setRay | ( | const Ray & | ray | ) | `[virtual, inherited]`

| Sets the ray which is to be used for this query.

virtual void Ogre::RaySceneQuery::setSortByDistance | ( | bool | sort,
|  | ushort | maxresults = `0`
| ) | `[virtual, inherited]`

  | Sets whether the results of this query will be sorted by distance along the ray. Remarks: Often you want to know what was the first object a ray intersected with, and this method allows you to ask the query to sort the results so that the nearest results are listed first. Note that because the query returns results based on bounding volumes, the ray may not actually intersect the detail of the objects returned from the query, just their bounding volumes. For this reason the caller is advised to use more detailed intersection tests on the results if a more accurate result is required; OGRE uses bounds checking in order to give the most speedy results since not all applications need extreme accuracy. Parameters:
  | sort | If true, results will be sorted.
  | maxresults | If sorting is enabled, this value can be used to constrain the maximum number of results that are returned. Please note (as above) that the use of bounding volumes mean that accuracy is not guaranteed; if in doubt, allow more results and filter them in more detail. 0 means unlimited results.

virtual void Ogre::SceneQuery::setWorldFragmentType | ( | enum WorldFragmentType | wft | ) | `[virtual, inherited]`

| Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed. Remarks: The application receiving the world geometry is expected to know what to do with it; inevitably this means that the application must have knowledge of at least some of the structures used by the custom SceneManager. The default setting is WFT_NONE.

## Member Data Documentation

ushort Ogre::RaySceneQuery::mMaxResults`[protected, inherited]`

| Definition at line 375 of file OgreSceneQuery.h.

SceneManager* Ogre::SceneQuery::mParentSceneMgr`[protected, inherited]`

| Definition at line 117 of file OgreSceneQuery.h.

uint32 Ogre::SceneQuery::mQueryMask`[protected, inherited]`

| Definition at line 118 of file OgreSceneQuery.h.

uint32 Ogre::SceneQuery::mQueryTypeMask`[protected, inherited]`

| Definition at line 119 of file OgreSceneQuery.h.

Ray Ogre::RaySceneQuery::mRay`[protected, inherited]`

| Definition at line 373 of file OgreSceneQuery.h.

RaySceneQueryResult Ogre::RaySceneQuery::mResult`[protected, inherited]`

| Definition at line 376 of file OgreSceneQuery.h.

bool Ogre::RaySceneQuery::mSortByDistance`[protected, inherited]`

| Definition at line 374 of file OgreSceneQuery.h.

std::set<WorldFragmentType> Ogre::SceneQuery::mSupportedWorldFragments`[protected, inherited]`

| Definition at line 120 of file OgreSceneQuery.h.

WorldFragmentType Ogre::SceneQuery::mWorldFragmentType`[protected, inherited]`

| Definition at line 121 of file OgreSceneQuery.h.

The documentation for this class was generated from the following file:

- OgreSceneManager.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:48:33 2008